#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <fcntl.h>
#include <time.h>
#include <sys/ioctl.h>
#include <sys/mount.h>

#include <linux/mtd/mtd.h>

int main(int argc,char *argv[])
{
   mtd_info_t meminfo;
   int Fd;
   unsigned long Length;
   
   if (1 >= argc)
   {
      fprintf(stderr,"You must specify a device\n");
      return 16;
   }
   
   // Open and size the device
   if ((Fd = open(argv[1],O_RDWR)) < 0)
   {
      fprintf(stderr,"File open error\n");
      return 8;
   }
   
   
   if (ioctl(Fd,MEMGETINFO,&meminfo) == 0)
   {
      erase_info_t erase;
      
      erase.length = meminfo.erasesize;
      printf("Erasesize 0x%lx\n", meminfo.erasesize);

      if (argc >= 2)
	      erase.start = atoi(argv[2]);
      else
	      erase.start = 0;
      
      printf("Performing Flash Erase of length %lu at offset %lu",erase.length, erase.start);
      fflush(stdout);
      
      if (ioctl(Fd,MEMERASE,&erase) != 0)
      {      
	 perror("\nMTD Erase failure");
	 close(Fd);
	 return 8;
      }
      printf(" done\n");
   }
   
   return 0;
}
