#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <fcntl.h>
#include <sys/stat.h>

#include <sys/ioctl.h>
#include <asm/types.h>
#include <linux/mtd/mtd.h>


char readbuf[512];
char oobbuf[16];


void main(int argc, char **argv)
{
  unsigned long ofs;
  int i,j;
  int fd;
  int ofd = -1;
  struct mtd_oob_buf  oob = {0,16,&oobbuf};
  mtd_info_t meminfo;

  if (argc < 3) {
	  printf("usage: %s <mtdname> <dumpname>\n", argv[0]);
	  exit(1);
  }
  fd = open(argv[1], O_RDONLY);

  if (fd == -1) {
    perror("open flash");
    exit (1);
  }
  
  if (ioctl(fd, MEMGETINFO, &meminfo) != 0) {
	  perror("MEMGETINFO");
	  close(fd);
	  exit (1);
  }

  if (meminfo.oobsize != 16 || meminfo.oobblock!=512) {
	  printf("Unknown flash (not normal NAND)\n");
	  close(fd);
	  exit(1);
  }


  ofd = open(argv[2], O_WRONLY | O_TRUNC | O_CREAT, 0644);
  if (ofd == -1) {
	  perror ("open outfile");
	  close(fd);
	  exit(1);
  }


  for (ofs = 0; ofs < meminfo.size ; ofs+=512) {
#if 1
	  if ( pread (fd, readbuf, 512, ofs) != 512) {
		  perror("pread");
		  close(fd);
		  close(ofd);
		  exit(1);
	  }
	  write(ofd, readbuf, 512);
#else
	  if ( (ofs & 0x1fff) == 0x600) ofs += (8192 -0x600);
#endif
	  oob.start = ofs;
	  printf("Dumping %lx\n",ofs);
	  if (ioctl(fd, MEMREADOOB, &oob) != 0) {
		  perror("ioctl(MEMREADOOB)");
		  close(fd);
		  close(ofd);
		  exit(1);
	  }
	  write(ofd, oobbuf, 16);
  }
  close(fd);
  close(ofd);
}
	  
